/*
 * Copyright (c) 2005-2010 KOM – Multimedia Communications Lab
 *
 * This file is part of Simonstrator.KOM.
 * 
 * Simonstrator.KOM is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 * 
 * PeerfactSim.KOM is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with PeerfactSim.KOM.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

package de.tudarmstadt.maki.simonstrator.api.component.vehicular.information;

import de.tudarmstadt.maki.simonstrator.api.common.graph.INodeID;
import de.tudarmstadt.maki.simonstrator.api.component.sensor.location.Location;
import de.tudarmstadt.maki.simonstrator.api.component.sis.type.SiSType;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.roadnetwork.RoadNetworkEdge;

public enum AvailableInformationAttributes {
	POSITION("position", Location.class), DATE("date", Long.class), VALUE("value"), OWNER("owner", INodeID.class), EDGE(
			"edge", RoadNetworkEdge.class), TTL(
					"ttl", Long.class), EXPECTED_DURATION(
							"duration", Long.class), STANDARD_DEVIATION_DURATION(
									"sd_duration"), TYPE("type", SiSType.class), COST("cost", Double.class);
	
	private final String attributeID;
	private final Class<? extends Object> clazz;

	private AvailableInformationAttributes(String pAttributeID, Class<? extends Object> clazz) {
		this.attributeID = pAttributeID;
		this.clazz = clazz;
	}
	
	private AvailableInformationAttributes(String pAttributeID) {
		this(pAttributeID, Object.class);
	}

	public Class<? extends Object> getExpectedClass() {
		return clazz;
	}
	
	/**
	 * @return the attributeID
	 */
	public String getAttributeID() {
		return attributeID;
	}
}
