package de.tudarmstadt.maki.simonstrator.api.component.vehicular.subscriptions.topic;

import de.tudarmstadt.maki.simonstrator.api.Host;
import de.tudarmstadt.maki.simonstrator.api.component.pubsub.attribute.Topic;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.information.PointInformation;
import de.tudarmstadt.maki.simonstrator.api.component.vehicular.subscriptions.SubscriptionTopicType;

public class GlobalTopic implements ProcessedTopic {

	private Topic _topic;

	public GlobalTopic(Topic pTopic) {
		_topic = pTopic;
	}

	@Override
	public Topic getTopic() {
		return _topic;
	}

	@Override
	public SubscriptionTopicType getTopicType() {
		return SubscriptionTopicType.GLOBAL;
	}

	@Override
	public boolean matchesInformationRequirements(PointInformation<?> pInformation) {
		return true;
	}

	@Override
	public boolean includes(ProcessedTopic pTopic) {
		return pTopic instanceof GlobalTopic;
	}

	@Override
	public boolean matchesHost(Host pHost) {
		return true;
	}

}
